//---------------------------------------------------------------------------
#include <vcl\vcl.h>
//#include <vcl\inifiles.hpp>	// TIniFile
#pragma hdrstop

#include "inifilesx.h"
#include "win32x.h"
//---------------------------------------------------------------------------
TIniFile *FindIni(AnsiString fn)
/*
	find ini-file fn.  Returns handle to ini file or NULL
*/
{
	AnsiString path; 	// holds path info for various purposes

	// if no filename then use application name
	if (fn.IsEmpty())	fn = ExtractFileName(Application->ExeName);

	// if no extension then append .ini
    if (ExtractFileExt(fn).IsEmpty())	fn += ".ini";

	// absolute path specified?
    path = ExtractFileDir(fn);
    if (!ExtractFileDrive(fn).IsEmpty() || (!path.IsEmpty() && path.IsPathDelimiter(1))) {
		if (FileExists(fn))	return new TIniFile(fn);

    // no absolute path specified.  Do search.
    } else {
    	// current folder
        path = AnsiString(".\\") + fn;
		if (FileExists(path))	return new TIniFile(path);

	    // then program folder
        path = ExtractFilePath(Application->ExeName) + fn;
        if (FileExists(path))	return new TIniFile(path);

        path = GetWindowsDirectoryX() + fn;
        // then windows folder
        if (FileExists(path))	return new TIniFile(path);
    }

    // still not found?  Return NULL
    return NULL;
}
//---------------------------------------------------------------------------
